Package org.codehaus.janino.util

# Interface Traverser<EX extends Throwable>

Type Parameters:
  `EX` - The exception that the "`traverse*()`" and "`visit*()`" methods may throw

All Known Implementing Classes:
  `AbstractTraverser`, `DeclarationCounter`

public interface Traverser<EX extends Throwable>
Implementations of this interface promise to traverses the subnodes of an AST. Derived classes override individual "`traverse*()`" methods to process specific nodes.

## Method Summary

Modifier and Type
Method
Description
`void`
`traverseAbstractCompilationUnit(Java.AbstractCompilationUnit acu)`
`void`
`traverseAbstractTypeBodyDeclaration(Java.AbstractTypeBodyDeclaration atbd)`
`void`
`traverseAbstractTypeDeclaration(Java.AbstractTypeDeclaration atd)`
`void`
`traverseAlternateConstructorInvocation(Java.AlternateConstructorInvocation aci)`
`void`
`traverseAmbiguousName(Java.AmbiguousName an)`
`void`
`traverseAnnotation(Java.Annotation a)`
`void`
`traverseAnonymousClassDeclaration(Java.AnonymousClassDeclaration acd)`
`void`
`traverseArrayAccessExpression(Java.ArrayAccessExpression aae)`
`void`
`traverseArrayCreationReference(Java.ArrayCreationReference acr)`
`void`
`traverseArrayInitializerOrRvalue(Java.ArrayInitializerOrRvalue aiorv)`
`void`
`traverseArrayLength(Java.ArrayLength al)`
`void`
`traverseArrayType(Java.ArrayType at)`
`void`
`traverseAssertStatement(Java.AssertStatement as)`
`void`
`traverseAssignment(Java.Assignment a)`
`void`
`traverseAtom(Java.Atom a)`
`void`
`traverseBinaryOperation(Java.BinaryOperation bo)`
`void`
`traverseBlock(Java.Block b)`
`void`
`traverseBooleanLiteral(Java.BooleanLiteral bl)`
`void`
`traverseBooleanRvalue(Java.BooleanRvalue brv)`
`void`
`traverseBreakableStatement(Java.BreakableStatement bs)`
`void`
`traverseBreakStatement(Java.BreakStatement bs)`
`void`
`traverseCast(Java.Cast c)`
`void`
`traverseCharacterLiteral(Java.CharacterLiteral cl)`
`void`
`traverseClassDeclaration(Java.AbstractClassDeclaration cd)`
`void`
`traverseClassInstanceCreationReference(Java.ClassInstanceCreationReference cicr)`
`void`
`traverseClassLiteral(Java.ClassLiteral cl)`
`void`
`traverseCompilationUnit(Java.CompilationUnit cu)`
`void`
`traverseConditionalExpression(Java.ConditionalExpression ce)`
`void`
`traverseConstructorDeclarator(Java.ConstructorDeclarator cd)`
`void`
`traverseConstructorInvocation(Java.ConstructorInvocation ci)`
`void`
`traverseContinuableStatement(Java.ContinuableStatement cs)`
`void`
`traverseContinueStatement(Java.ContinueStatement cs)`
`void`
`traverseCrement(Java.Crement c)`
`void`
`traverseDoStatement(Java.DoStatement ds)`
`void`
`traverseElementValue(Java.ElementValue ev)`
`void`
`traverseElementValueArrayInitializer(Java.ElementValueArrayInitializer evai)`
`void`
`traverseEmptyStatement(Java.EmptyStatement es)`
`void`
`traverseEnumConstant(Java.EnumConstant ec)`
`void`
`traverseExpressionStatement(Java.ExpressionStatement es)`
`void`
`traverseFieldAccess(Java.FieldAccess fa)`
`void`
`traverseFieldAccessExpression(Java.FieldAccessExpression fae)`
`void`
`traverseFieldDeclaration(Java.FieldDeclaration fd)`
`void`
`traverseFloatingPointLiteral(Java.FloatingPointLiteral fpl)`
`void`
`traverseForEachStatement(Java.ForEachStatement fes)`
`void`
`traverseFormalParameter(Java.FunctionDeclarator.FormalParameter formalParameter)`
`void`
`traverseFormalParameters(Java.FunctionDeclarator.FormalParameters formalParameters)`
`void`
`traverseForStatement(Java.ForStatement fs)`
`void`
`traverseFunctionDeclarator(Java.FunctionDeclarator fd)`
`void`
`traverseIfStatement(Java.IfStatement is)`
`void`
`traverseImportDeclaration(Java.AbstractCompilationUnit.ImportDeclaration id)`
`void`
`traverseInitializer(Java.Initializer i)`
`void`
`traverseInstanceof(Java.Instanceof io)`
`void`
`traverseIntegerLiteral(Java.IntegerLiteral il)`
`void`
`traverseInterfaceDeclaration(Java.InterfaceDeclaration id)`
`void`
`traverseInvocation(Java.Invocation i)`
`void`
`traverseLabeledStatement(Java.LabeledStatement ls)`
`void`
`traverseLambdaExpression(Java.LambdaExpression le)`
`void`
`traverseLiteral(Java.Literal l)`
`void`
`traverseLocalClassDeclaration(Java.LocalClassDeclaration lcd)`
`void`
`traverseLocalClassDeclarationStatement(Java.LocalClassDeclarationStatement lcds)`
`void`
`traverseLocalVariableAccess(Java.LocalVariableAccess lva)`
`void`
`traverseLocalVariableDeclarationStatement(Java.LocalVariableDeclarationStatement lvds)`
`void`
`traverseLocalVariableDeclaratorResource(Java.TryStatement.LocalVariableDeclaratorResource lvdr)`
`void`
`traverseLocated(Java.Located l)`
`void`
`traverseLvalue(Java.Lvalue lv)`
`void`
`traverseMarkerAnnotation(Java.MarkerAnnotation ma)`
`void`
`traverseMemberAnnotationTypeDeclaration(Java.MemberAnnotationTypeDeclaration matd)`
`void`
`traverseMemberClassDeclaration(Java.MemberClassDeclaration mcd)`
`void`
`traverseMemberEnumDeclaration(Java.MemberEnumDeclaration med)`
`void`
`traverseMemberInterfaceDeclaration(Java.MemberInterfaceDeclaration mid)`
`void`
`traverseMethodDeclarator(Java.MethodDeclarator md)`
`void`
`traverseMethodInvocation(Java.MethodInvocation mi)`
`void`
`traverseMethodReference(Java.MethodReference mr)`
`void`
`traverseModularCompilationUnit(Java.ModularCompilationUnit mcu)`
`void`
`traverseNamedClassDeclaration(Java.NamedClassDeclaration ncd)`
`void`
`traverseNewAnonymousClassInstance(Java.NewAnonymousClassInstance naci)`
`void`
`traverseNewArray(Java.NewArray na)`
`void`
`traverseNewClassInstance(Java.NewClassInstance nci)`
`void`
`traverseNewInitializedArray(Java.NewInitializedArray nia)`
`void`
`traverseNormalAnnotation(Java.NormalAnnotation na)`
`void`
`traverseNullLiteral(Java.NullLiteral nl)`
`void`
`traversePackage(Java.Package p)`
`void`
`traversePackageMemberAnnotationTypeDeclaration(Java.PackageMemberAnnotationTypeDeclaration pmatd)`
`void`
`traversePackageMemberClassDeclaration(Java.PackageMemberClassDeclaration pmcd)`
`void`
`traversePackageMemberEnumDeclaration(Java.PackageMemberEnumDeclaration pmed)`
`void`
`traversePackageMemberInterfaceDeclaration(Java.PackageMemberInterfaceDeclaration pmid)`
`void`
`traverseParameterAccess(Java.ParameterAccess pa)`
`void`
`traverseParenthesizedExpression(Java.ParenthesizedExpression pe)`
`void`
`traversePrimitiveType(Java.PrimitiveType bt)`
`void`
`traverseQualifiedThisReference(Java.QualifiedThisReference qtr)`
`void`
`traverseReferenceType(Java.ReferenceType rt)`
`void`
`traverseReturnStatement(Java.ReturnStatement rs)`
`void`
`traverseRvalue(Java.Rvalue rv)`
`void`
`traverseRvalueMemberType(Java.RvalueMemberType rmt)`
`void`
`traverseSimpleLiteral(Java.SimpleConstant sl)`
`void`
`traverseSimpleType(Java.SimpleType st)`
`void`
`traverseSingleElementAnnotation(Java.SingleElementAnnotation sea)`
`void`
`traverseSingleStaticImportDeclaration(Java.AbstractCompilationUnit.SingleStaticImportDeclaration stid)`
`void`
`traverseSingleTypeImportDeclaration(Java.AbstractCompilationUnit.SingleTypeImportDeclaration stid)`
`void`
`traverseStatement(Java.Statement s)`
`void`
`traverseStaticImportOnDemandDeclaration(Java.AbstractCompilationUnit.StaticImportOnDemandDeclaration siodd)`
`void`
`traverseStringLiteral(Java.StringLiteral sl)`
`void`
`traverseSuperclassFieldAccessExpression(Java.SuperclassFieldAccessExpression scfae)`
`void`
`traverseSuperclassMethodInvocation(Java.SuperclassMethodInvocation smi)`
`void`
`traverseSuperConstructorInvocation(Java.SuperConstructorInvocation sci)`
`void`
`traverseSwitchStatement(Java.SwitchStatement ss)`
`void`
`traverseSynchronizedStatement(Java.SynchronizedStatement ss)`
`void`
`traverseTextBlock(Java.TextBlock tb)`
`void`
`traverseThisReference(Java.ThisReference tr)`
`void`
`traverseThrowStatement(Java.ThrowStatement ts)`
`void`
`traverseTryStatement(Java.TryStatement ts)`
`void`
`traverseType(Java.Type t)`
`void`
`traverseTypeImportOnDemandDeclaration(Java.AbstractCompilationUnit.TypeImportOnDemandDeclaration tiodd)`
`void`
`traverseUnaryOperation(Java.UnaryOperation uo)`
`void`
`traverseVariableAccessResource(Java.TryStatement.VariableAccessResource var)`
`void`
`traverseWhileStatement(Java.WhileStatement ws)`
`void`
`visitAbstractCompilationUnit(Java.AbstractCompilationUnit cu)`
`void`
`visitAnnotation(Java.Annotation a)`
`void`
`visitAtom(Java.Atom a)`
`void`
`visitBlockStatement(Java.BlockStatement bs)`
`void`
`visitElementValue(Java.ElementValue ev)`
`void`
`visitImportDeclaration(Java.AbstractCompilationUnit.ImportDeclaration id)`
`void`
`visitTypeBodyDeclaration(Java.TypeBodyDeclaration tbd)`
`void`
`visitTypeDeclaration(Java.TypeDeclaration td)`

## Method Details

### visitAbstractCompilationUnit

void visitAbstractCompilationUnit(Java.AbstractCompilationUnit cu) throws EX

Throws:
  `EX`

### visitImportDeclaration

void visitImportDeclaration(Java.AbstractCompilationUnit.ImportDeclaration id) throws EX

Throws:
  `EX`

### visitTypeDeclaration

void visitTypeDeclaration(Java.TypeDeclaration td) throws EX

Throws:
  `EX`

### visitTypeBodyDeclaration

void visitTypeBodyDeclaration(Java.TypeBodyDeclaration tbd) throws EX

Throws:
  `EX`

### visitBlockStatement

void visitBlockStatement(Java.BlockStatement bs) throws EX

Throws:
  `EX`

### visitAtom

void visitAtom(Java.Atom a) throws EX

Throws:
  `EX`

### visitElementValue

void visitElementValue(Java.ElementValue ev) throws EX

Throws:
  `EX`

### visitAnnotation

void visitAnnotation(Java.Annotation a) throws EX

Throws:
  `EX`

### traverseAbstractCompilationUnit

void traverseAbstractCompilationUnit(Java.AbstractCompilationUnit acu) throws EX

Throws:
  `EX`

### traverseCompilationUnit

void traverseCompilationUnit(Java.CompilationUnit cu) throws EX

Throws:
  `EX`

### traverseModularCompilationUnit

void traverseModularCompilationUnit(Java.ModularCompilationUnit mcu) throws EX

Throws:
  `EX`

### traverseSingleTypeImportDeclaration

void traverseSingleTypeImportDeclaration(Java.AbstractCompilationUnit.SingleTypeImportDeclaration stid) throws EX

Throws:
  `EX`

### traverseTypeImportOnDemandDeclaration

void traverseTypeImportOnDemandDeclaration(Java.AbstractCompilationUnit.TypeImportOnDemandDeclaration tiodd) throws EX

Throws:
  `EX`

### traverseSingleStaticImportDeclaration

void traverseSingleStaticImportDeclaration(Java.AbstractCompilationUnit.SingleStaticImportDeclaration stid) throws EX

Throws:
  `EX`

### traverseStaticImportOnDemandDeclaration

void traverseStaticImportOnDemandDeclaration(Java.AbstractCompilationUnit.StaticImportOnDemandDeclaration siodd) throws EX

Throws:
  `EX`

### traverseImportDeclaration

void traverseImportDeclaration(Java.AbstractCompilationUnit.ImportDeclaration id) throws EX

Throws:
  `EX`

### traverseAnonymousClassDeclaration

void traverseAnonymousClassDeclaration(Java.AnonymousClassDeclaration acd) throws EX

Throws:
  `EX`

### traverseLocalClassDeclaration

void traverseLocalClassDeclaration(Java.LocalClassDeclaration lcd) throws EX

Throws:
  `EX`

### traversePackageMemberClassDeclaration

void traversePackageMemberClassDeclaration(Java.PackageMemberClassDeclaration pmcd) throws EX

Throws:
  `EX`

### traverseMemberInterfaceDeclaration

void traverseMemberInterfaceDeclaration(Java.MemberInterfaceDeclaration mid) throws EX

Throws:
  `EX`

### traversePackageMemberInterfaceDeclaration

void traversePackageMemberInterfaceDeclaration(Java.PackageMemberInterfaceDeclaration pmid) throws EX

Throws:
  `EX`

### traverseMemberClassDeclaration

void traverseMemberClassDeclaration(Java.MemberClassDeclaration mcd) throws EX

Throws:
  `EX`

### traverseConstructorDeclarator

void traverseConstructorDeclarator(Java.ConstructorDeclarator cd) throws EX

Throws:
  `EX`

### traverseInitializer

void traverseInitializer(Java.Initializer i) throws EX

Throws:
  `EX`

### traverseMethodDeclarator

void traverseMethodDeclarator(Java.MethodDeclarator md) throws EX

Throws:
  `EX`

### traverseFieldDeclaration

void traverseFieldDeclaration(Java.FieldDeclaration fd) throws EX

Throws:
  `EX`

### traverseLabeledStatement

void traverseLabeledStatement(Java.LabeledStatement ls) throws EX

Throws:
  `EX`

### traverseBlock

void traverseBlock(Java.Block b) throws EX

Throws:
  `EX`

### traverseExpressionStatement

void traverseExpressionStatement(Java.ExpressionStatement es) throws EX

Throws:
  `EX`

### traverseIfStatement

void traverseIfStatement(Java.IfStatement is) throws EX

Throws:
  `EX`

### traverseForStatement

void traverseForStatement(Java.ForStatement fs) throws EX

Throws:
  `EX`

### traverseForEachStatement

void traverseForEachStatement(Java.ForEachStatement fes) throws EX

Throws:
  `EX`

### traverseWhileStatement

void traverseWhileStatement(Java.WhileStatement ws) throws EX

Throws:
  `EX`

### traverseTryStatement

void traverseTryStatement(Java.TryStatement ts) throws EX

Throws:
  `EX`

### traverseSwitchStatement

void traverseSwitchStatement(Java.SwitchStatement ss) throws EX

Throws:
  `EX`

### traverseSynchronizedStatement

void traverseSynchronizedStatement(Java.SynchronizedStatement ss) throws EX

Throws:
  `EX`

### traverseDoStatement

void traverseDoStatement(Java.DoStatement ds) throws EX

Throws:
  `EX`

### traverseLocalVariableDeclarationStatement

void traverseLocalVariableDeclarationStatement(Java.LocalVariableDeclarationStatement lvds) throws EX

Throws:
  `EX`

### traverseReturnStatement

void traverseReturnStatement(Java.ReturnStatement rs) throws EX

Throws:
  `EX`

### traverseThrowStatement

void traverseThrowStatement(Java.ThrowStatement ts) throws EX

Throws:
  `EX`

### traverseBreakStatement

void traverseBreakStatement(Java.BreakStatement bs) throws EX

Throws:
  `EX`

### traverseContinueStatement

void traverseContinueStatement(Java.ContinueStatement cs) throws EX

Throws:
  `EX`

### traverseAssertStatement

void traverseAssertStatement(Java.AssertStatement as) throws EX

Throws:
  `EX`

### traverseEmptyStatement

void traverseEmptyStatement(Java.EmptyStatement es) throws EX

Throws:
  `EX`

### traverseLocalClassDeclarationStatement

void traverseLocalClassDeclarationStatement(Java.LocalClassDeclarationStatement lcds) throws EX

Throws:
  `EX`

### traversePackage

void traversePackage(Java.Package p) throws EX

Throws:
  `EX`

### traverseArrayLength

void traverseArrayLength(Java.ArrayLength al) throws EX

Throws:
  `EX`

### traverseAssignment

void traverseAssignment(Java.Assignment a) throws EX

Throws:
  `EX`

### traverseUnaryOperation

void traverseUnaryOperation(Java.UnaryOperation uo) throws EX

Throws:
  `EX`

### traverseBinaryOperation

void traverseBinaryOperation(Java.BinaryOperation bo) throws EX

Throws:
  `EX`

### traverseCast

void traverseCast(Java.Cast c) throws EX

Throws:
  `EX`

### traverseClassLiteral

void traverseClassLiteral(Java.ClassLiteral cl) throws EX

Throws:
  `EX`

### traverseConditionalExpression

void traverseConditionalExpression(Java.ConditionalExpression ce) throws EX

Throws:
  `EX`

### traverseCrement

void traverseCrement(Java.Crement c) throws EX

Throws:
  `EX`

### traverseInstanceof

void traverseInstanceof(Java.Instanceof io) throws EX

Throws:
  `EX`

### traverseMethodInvocation

void traverseMethodInvocation(Java.MethodInvocation mi) throws EX

Throws:
  `EX`

### traverseSuperclassMethodInvocation

void traverseSuperclassMethodInvocation(Java.SuperclassMethodInvocation smi) throws EX

Throws:
  `EX`

### traverseLiteral

void traverseLiteral(Java.Literal l) throws EX

Throws:
  `EX`

### traverseIntegerLiteral

void traverseIntegerLiteral(Java.IntegerLiteral il) throws EX

Throws:
  `EX`

### traverseFloatingPointLiteral

void traverseFloatingPointLiteral(Java.FloatingPointLiteral fpl) throws EX

Throws:
  `EX`

### traverseBooleanLiteral

void traverseBooleanLiteral(Java.BooleanLiteral bl) throws EX

Throws:
  `EX`

### traverseCharacterLiteral

void traverseCharacterLiteral(Java.CharacterLiteral cl) throws EX

Throws:
  `EX`

### traverseStringLiteral

void traverseStringLiteral(Java.StringLiteral sl) throws EX

Throws:
  `EX`

### traverseTextBlock

void traverseTextBlock(Java.TextBlock tb) throws EX

Throws:
  `EX`

### traverseNullLiteral

void traverseNullLiteral(Java.NullLiteral nl) throws EX

Throws:
  `EX`

### traverseSimpleLiteral

void traverseSimpleLiteral(Java.SimpleConstant sl) throws EX

Throws:
  `EX`

### traverseNewAnonymousClassInstance

void traverseNewAnonymousClassInstance(Java.NewAnonymousClassInstance naci) throws EX

Throws:
  `EX`

### traverseNewArray

void traverseNewArray(Java.NewArray na) throws EX

Throws:
  `EX`

### traverseNewInitializedArray

void traverseNewInitializedArray(Java.NewInitializedArray nia) throws EX

Throws:
  `EX`

### traverseArrayInitializerOrRvalue

void traverseArrayInitializerOrRvalue(Java.ArrayInitializerOrRvalue aiorv) throws EX

Throws:
  `EX`

### traverseNewClassInstance

void traverseNewClassInstance(Java.NewClassInstance nci) throws EX

Throws:
  `EX`

### traverseParameterAccess

void traverseParameterAccess(Java.ParameterAccess pa) throws EX

Throws:
  `EX`

### traverseQualifiedThisReference

void traverseQualifiedThisReference(Java.QualifiedThisReference qtr) throws EX

Throws:
  `EX`

### traverseThisReference

void traverseThisReference(Java.ThisReference tr) throws EX

Throws:
  `EX`

### traverseLambdaExpression

void traverseLambdaExpression(Java.LambdaExpression le) throws EX

Throws:
  `EX`

### traverseMethodReference

void traverseMethodReference(Java.MethodReference mr) throws EX

Throws:
  `EX`

### traverseClassInstanceCreationReference

void traverseClassInstanceCreationReference(Java.ClassInstanceCreationReference cicr) throws EX

Throws:
  `EX`

### traverseArrayCreationReference

void traverseArrayCreationReference(Java.ArrayCreationReference acr) throws EX

Throws:
  `EX`

### traverseArrayType

void traverseArrayType(Java.ArrayType at) throws EX

Throws:
  `EX`

### traversePrimitiveType

void traversePrimitiveType(Java.PrimitiveType bt) throws EX

Throws:
  `EX`

### traverseReferenceType

void traverseReferenceType(Java.ReferenceType rt) throws EX

Throws:
  `EX`

### traverseRvalueMemberType

void traverseRvalueMemberType(Java.RvalueMemberType rmt) throws EX

Throws:
  `EX`

### traverseSimpleType

void traverseSimpleType(Java.SimpleType st) throws EX

Throws:
  `EX`

### traverseAlternateConstructorInvocation

void traverseAlternateConstructorInvocation(Java.AlternateConstructorInvocation aci) throws EX

Throws:
  `EX`

### traverseSuperConstructorInvocation

void traverseSuperConstructorInvocation(Java.SuperConstructorInvocation sci) throws EX

Throws:
  `EX`

### traverseAmbiguousName

void traverseAmbiguousName(Java.AmbiguousName an) throws EX

Throws:
  `EX`

### traverseArrayAccessExpression

void traverseArrayAccessExpression(Java.ArrayAccessExpression aae) throws EX

Throws:
  `EX`

### traverseFieldAccess

void traverseFieldAccess(Java.FieldAccess fa) throws EX

Throws:
  `EX`

### traverseFieldAccessExpression

void traverseFieldAccessExpression(Java.FieldAccessExpression fae) throws EX

Throws:
  `EX`

### traverseSuperclassFieldAccessExpression

void traverseSuperclassFieldAccessExpression(Java.SuperclassFieldAccessExpression scfae) throws EX

Throws:
  `EX`

### traverseLocalVariableAccess

void traverseLocalVariableAccess(Java.LocalVariableAccess lva) throws EX

Throws:
  `EX`

### traverseParenthesizedExpression

void traverseParenthesizedExpression(Java.ParenthesizedExpression pe) throws EX

Throws:
  `EX`

### traverseElementValueArrayInitializer

void traverseElementValueArrayInitializer(Java.ElementValueArrayInitializer evai) throws EX

Throws:
  `EX`

### traverseElementValue

void traverseElementValue(Java.ElementValue ev) throws EX

Throws:
  `EX`

### traverseSingleElementAnnotation

void traverseSingleElementAnnotation(Java.SingleElementAnnotation sea) throws EX

Throws:
  `EX`

### traverseAnnotation

void traverseAnnotation(Java.Annotation a) throws EX

Throws:
  `EX`

### traverseNormalAnnotation

void traverseNormalAnnotation(Java.NormalAnnotation na) throws EX

Throws:
  `EX`

### traverseMarkerAnnotation

void traverseMarkerAnnotation(Java.MarkerAnnotation ma) throws EX

Throws:
  `EX`

### traverseClassDeclaration

void traverseClassDeclaration(Java.AbstractClassDeclaration cd) throws EX

Throws:
  `EX`

### traverseAbstractTypeDeclaration

void traverseAbstractTypeDeclaration(Java.AbstractTypeDeclaration atd) throws EX

Throws:
  `EX`

### traverseNamedClassDeclaration

void traverseNamedClassDeclaration(Java.NamedClassDeclaration ncd) throws EX

Throws:
  `EX`

### traverseInterfaceDeclaration

void traverseInterfaceDeclaration(Java.InterfaceDeclaration id) throws EX

Throws:
  `EX`

### traverseFunctionDeclarator

void traverseFunctionDeclarator(Java.FunctionDeclarator fd) throws EX

Throws:
  `EX`

### traverseFormalParameters

void traverseFormalParameters(Java.FunctionDeclarator.FormalParameters formalParameters) throws EX

Throws:
  `EX`

### traverseFormalParameter

void traverseFormalParameter(Java.FunctionDeclarator.FormalParameter formalParameter) throws EX

Throws:
  `EX`

### traverseAbstractTypeBodyDeclaration

void traverseAbstractTypeBodyDeclaration(Java.AbstractTypeBodyDeclaration atbd) throws EX

Throws:
  `EX`

### traverseStatement

void traverseStatement(Java.Statement s) throws EX

Throws:
  `EX`

### traverseBreakableStatement

void traverseBreakableStatement(Java.BreakableStatement bs) throws EX

Throws:
  `EX`

### traverseContinuableStatement

void traverseContinuableStatement(Java.ContinuableStatement cs) throws EX

Throws:
  `EX`

### traverseRvalue

void traverseRvalue(Java.Rvalue rv) throws EX

Throws:
  `EX`

### traverseBooleanRvalue

void traverseBooleanRvalue(Java.BooleanRvalue brv) throws EX

Throws:
  `EX`

### traverseInvocation

void traverseInvocation(Java.Invocation i) throws EX

Throws:
  `EX`

### traverseConstructorInvocation

void traverseConstructorInvocation(Java.ConstructorInvocation ci) throws EX

Throws:
  `EX`

### traverseEnumConstant

void traverseEnumConstant(Java.EnumConstant ec) throws EX

Throws:
  `EX`

### traversePackageMemberEnumDeclaration

void traversePackageMemberEnumDeclaration(Java.PackageMemberEnumDeclaration pmed) throws EX

Throws:
  `EX`

### traverseMemberEnumDeclaration

void traverseMemberEnumDeclaration(Java.MemberEnumDeclaration med) throws EX

Throws:
  `EX`

### traversePackageMemberAnnotationTypeDeclaration

void traversePackageMemberAnnotationTypeDeclaration(Java.PackageMemberAnnotationTypeDeclaration pmatd) throws EX

Throws:
  `EX`

### traverseMemberAnnotationTypeDeclaration

void traverseMemberAnnotationTypeDeclaration(Java.MemberAnnotationTypeDeclaration matd) throws EX

Throws:
  `EX`

### traverseLvalue

void traverseLvalue(Java.Lvalue lv) throws EX

Throws:
  `EX`

### traverseType

void traverseType(Java.Type t) throws EX

Throws:
  `EX`

### traverseAtom

void traverseAtom(Java.Atom a) throws EX

Throws:
  `EX`

### traverseLocated

void traverseLocated(Java.Located l) throws EX

Throws:
  `EX`

### traverseLocalVariableDeclaratorResource

void traverseLocalVariableDeclaratorResource(Java.TryStatement.LocalVariableDeclaratorResource lvdr) throws EX

Throws:
  `EX`

### traverseVariableAccessResource

void traverseVariableAccessResource(Java.TryStatement.VariableAccessResource var) throws EX

Throws:
  `EX`